<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PenerimaanbarangService;
use App\Http\Validators\PenerimaanbarangValidator;
use App\Http\Services\LokasiitemService;
use App\Http\Services\KapalService;
use App\Http\Services\PopenerimaanService;
use App\Http\Services\ItempenerimaanbarangService;
use App\Http\Services\ItempopenerimaanService;
use App\Http\Services\StokkapalService;
use App\Http\Services\VoyagesService;
use App\Http\Services\ActivitylogService;
use PDF;

class PenerimaanbarangController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $lokasiitem;
    private $kapal;
    private $popenerimaan;
    private $itempenerimaanbarang;
    private $itempopenerimaan;
    private $stokkapal;
    private $voyage;
    private $activityLog;

    /**
     * Penerimaanbarang constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PenerimaanbarangService();
        $this->validator = new PenerimaanbarangValidator();
        $this->lokasiitem = new LokasiitemService();
        $this->kapal = new KapalService();

        $this->popenerimaan = new PopenerimaanService();
        $this->itempenerimaanbarang = new ItempenerimaanbarangService();
        $this->itempopenerimaan = new ItempopenerimaanService();
        $this->stokkapal = new StokkapalService();
        $this->voyage = new VoyagesService();
        $this->activityLog = new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        $this->validator->beforeInsert($input);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $auth = json_decode($request->session()->get('auth'));

            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["urlTransaksi"] = "penerimaanbarang";
            $input["namaTransaksi"] = "Penerimaan Barang";
            $input["refId"] = $input["receiptNumber"] = $this->baseService->getLastestID("PB" . date("y") . $auth->orgId);

            $ID = $this->baseService->store($input);

            $this->itempenerimaanbarang->store($input);

            $data = $this->baseService->getPrepareUpdateStock($input);
            $this->stokkapal->updateStock($data);

            $this->itempopenerimaan->updateQtyRemaining($input);
            $input["deskripsi"] = $auth->name . " just <b>created</b> new Penerimaan Barang <a href=\"" . url("administrator/penerimaanbarang/" . $ID) . "\">" . $input["receiptNumber"] . "</a>";
            $this->activityLog->store($input);

            $this->baseService->saveStaging($input);

            DB::commit();

            $nOpenItems = $this->itempopenerimaan->getStatusItems($input["poNumber"]);
            if ($nOpenItems > 0) {
                $this->popenerimaan->updateStatusPO(0, $input);
            } else {
                $this->popenerimaan->updateStatusPO(1, $input);
            }

            $this->sync();
            return redirect()->to("administrator/popenerimaan/" . $input["poID"])->with("successMessages", "Data sudah berhasil disimpan dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "poNumber" => "poNumber", "kapalId" => "kapalId", "locationId" => "locationId", "userId" => "userId", "receiptNumber" => "receiptNumber", "receiptDate" => "receiptDate"
        ];
        $this->data["criteria"] = [
            "poNumber" => "poNumber", "kapalId" => "kapalId", "locationId" => "locationId", "userId" => "userId", "receiptNumber" => "receiptNumber", "receiptDate" => "receiptDate"
        ];
        $this->data["ordering"] = [
            "poNumber:asc" => "poNumber", "kapalId:asc" => "kapalId", "locationId:asc" => "locationId", "userId:asc" => "userId", "receiptNumber:asc" => "receiptNumber", "receiptDate:asc" => "receiptDate"
        ];
        $this->data["penerimaanbarangs"] = $this->baseService->paging($request);
        return view("modules.penerimaanbarang.penerimaanbarang_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["penerimaanbarang"] = $this->baseService->show($id);
        return view("modules.penerimaanbarang.penerimaanbarang_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/penerimaanbarang")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request, $id)
    {
        $this->data["criteria"] = [
            "deskripsi"     => "Deskripsi",
            "part_number"    => "Part Number",
            "namaItem"      => "Kode Item"
        ];
        $this->data["poNumber"] = $id;
        $this->data["popenerimaan"] = $this->popenerimaan->show($id);
        $this->data["lokasiitems"] = $this->lokasiitem->index($request);
        // $this->data["voyages"] = $this->voyage->index();
        return view("modules.penerimaanbarang.penerimaanbarang_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {

        $this->data["penerimaanbarang"] = $this->baseService->show($id);
        if ($this->data["penerimaanbarang"]) {
            $this->data["popenerimaan"] = $this->popenerimaan->showBasedOnPONumber($request, $this->data["penerimaanbarang"]);
            $this->data["listItems"] = $this->itempenerimaanbarang->showBasedOnPenerimaanbarang($request, $this->data["penerimaanbarang"]);
            return view("modules.penerimaanbarang.penerimaanbarang_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function search(Request $request)
    {
        $data = $this->itempopenerimaan->paging($request);
        echo json_encode($data);
    }


    public function reportBarangMasuk(Request $request, $ID)
    {
        PDF::SetTitle('Laporan Barang Masuk');
        PDF::AddPage();

        $data['totalPageCount'] = PDF::getAliasNbPages();
        $data["penerimaanbarang"] = $this->baseService->show($ID);
        if ($data["penerimaanbarang"]) {
            $data["kapal"] = $this->kapal->show($data["penerimaanbarang"]->kapalId);
            $data["popenerimaan"] = $this->popenerimaan->showBasedOnPONumber($request, $data["penerimaanbarang"]);
            $data["listItems"] = $this->itempenerimaanbarang->showBasedOnPenerimaanbarang($request, $data["penerimaanbarang"]);

            $view = \View::make("modules.penerimaanbarang.penerimaan-pdf", $data);
            $htmlContent = $view->render();
            PDF::writeHTML($htmlContent, true, false, true, false . "");
            PDF::Output('laporanbarangmasuk.pdf');
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }
}
